﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Common
{
    public static class ListExtension
    {
        /// <summary>
        /// 集合转换为符号分割的字符串
        /// </summary>
        /// <param name="list">集合</param>
        /// <param name="separator"></param>
        /// <returns></returns>
        public static string Join(this IEnumerable<string> list, string separator = ",")
        {
            return string.Join(separator, list.ToList());
        }

        /// <summary>
        /// 随机获取集合规定数目的不相同的数据集合
        /// </summary>
        /// <param name="list"></param>
        /// <param name="max"></param>
        /// <returns></returns>
        public static IEnumerable<string> RandomList(this IEnumerable<string> list, int max)
        {
            var rList = new List<string>();
            list = list.Distinct();
            if (list.Count() <= max)
            {
                return list;
            }
            for (int i = 0; i < max; i++)
            {
                var ram = new Random(Guid.NewGuid().GetHashCode());
                var number = ram.Next(0, list.Count());
                var value = list.ToList()[number];
                if (rList.Contains(value))
                    i--; 
                else
                    rList.Add(value);
            }
            return rList;
        }
    }
}
