﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.IO;
using System.Net;
using System.Net.Http;
using System.Text;

namespace Common
{
    public class ApiHelper
    {
        #region 配置
        private static string _url = null;
        private  static HttpHelper httpHelper = new HttpHelper();
     
        #endregion

        /// <summary>
        /// get请求
        /// </summary>
        /// <param name="url"></param>
        /// <returns></returns>
        public static string Get(string url, WebHeaderCollection header)
        {
            return httpHelper.GetData(new HttpItem
            {
                Url = url,
                Method = "get",
                Header = header
            }).Html;
        }
        /// <summary>
        /// get请求
        /// </summary>
        /// <param name="url"></param>
        /// <returns></returns>
        public static string Get(string url)
        {
            return httpHelper.GetData(new HttpItem
            {
                Url = url,
                Method = "get"

            }).Html;
        }

        /// <summary>
        /// post请求
        /// </summary>
        /// <param name="url"></param>
        /// <param name="jsonObj"></param>
        /// <returns></returns>
        public static string Post(string url, object jsonObj)
        {
            return httpHelper.GetData(new HttpItem
            {
                Url = url,
                Method = "post",
                ContentType = "application/json",
                Timeout = 90 * 1000,
                ReadWriteTimeout = 90 * 1000,
                Encoding = Encoding.UTF8,
                Postdata = jsonObj.TryToJson(),

            }).Html.TryJsonToT<BaseJsonResult>().body.ToString();
        }


        private static void AddHeader(HttpClient http, Dictionary<string, string> header)
        {
            if (header == null)
                return;
            foreach (var item in header)
            {
                http.DefaultRequestHeaders.Add(item.Key, item.Value);//添加headers
            }
        }


    }
    public class BaseJsonResult
    {
        /// <summary>
        /// 状态编码
        /// </summary>
        public int code { get; set; }

        /// <summary>
        /// 数据
        /// </summary>
        public object body { get; set; }

        /// <summary>
        /// 返回信息
        /// </summary>
        public string msg { get; set; }

        /// <summary>
        /// 发送时间
        /// </summary>
        public DateTime stime { get; set; }
    }
}
