﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Common.Models
{
    public class PaginationQuery
    {
        /// <summary>
        /// 每页行数
        /// </summary>
        public int Rows { get; set; }

        /// <summary>
        /// 当前页
        /// </summary>
        public int Page { get; set; }

        /// <summary>
        /// 排序列
        /// </summary>
        public string Sidx { get; set; }

        /// <summary>
        /// 排序类型，DESC或者ASC，默认DESC
        /// </summary>
        public string Sord { get; set; } = "DESC";
    }

    public class PaginationDTO<T>: PaginationQuery
    {
        /// <summary>
        /// 数据
        /// </summary>
        public T Data { get; set; }
        /// <summary>
        /// 数据条数
        /// </summary>
        public int Total { get; set; }
        /// <summary>
        /// 数据分页
        /// </summary>
        public int Pages
        {
            get
            {
                if (Total > 0)
                {
                    return Total % this.Rows == 0 ? Total / this.Rows : Total / this.Rows + 1;
                }
                else
                {
                    return 0;
                }
            }
        }
    }
}
