﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Models.APIBase
{
    #region 单条数据
    /// <summary>
    ///  单条数据
    /// </summary>
    public class ApiOne<T>
    {
        /// <summary>
        /// 错误码
        /// </summary>
        public int code { get; set; }

        /// <summary>
        /// 错误信息
        /// </summary>
        public string msg { get; set; }

        /// <summary>
        /// 服务器时间
        /// unix格式
        /// </summary>
        public long stime { get; set; }
        /// <summary>
        /// 是否加密
        /// </summary>
        public bool Encrypted { get; set; }
        /// <summary>
        /// 数据
        /// </summary>
        public T body { get; set; }
    }
    #endregion

    #region 数据集 含条数 用于分页
    /// <summary>
    /// 数据集
    /// </summary>
    /// <typeparam name="T"></typeparam>
    public class ApiList<T>
    {
        /// <summary>
        /// 错误码
        /// </summary>
        public int code { get; set; }

        /// <summary>
        /// 错误信息
        /// </summary>
        public string msg { get; set; }

        /// <summary>
        /// 服务器时间
        /// unix格式
        /// </summary>
        public long stime { get; set; }
        /// <summary>
        /// 是否加密
        /// </summary>
        public bool Encrypted { get; set; }
        /// <summary>
        /// 数据
        /// </summary>
        public Body<List<T>> body { get; set; }
    }
    #endregion

    #region api数据
    /// <summary>
    /// api数据
    /// </summary>
    /// <typeparam name="T"></typeparam>
    public class Body<T>
    {
        /// <summary>
        /// 总条数 分页用
        /// </summary>
        public int count { get; set; }

        /// <summary>
        /// object数据
        /// </summary>
        public T data { get; set; }
    }
    #endregion

}
